diff -r 3f1e7d35d0ab -r 821e8eadeaff src/protocol.c
--- a/src/protocol.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/protocol.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -30,10 +32,10 @@
 /**
  * @file   protocol.c
  * @date   Wed Jun 23 09:40:39 2010
- * 
+ *
  * @brief  The code that handles the IEEE-1588 protocol and state machine
- * 
- * 
+ *
+ *
  */
 
 #include "ptpd.h"
@@ -73,7 +75,7 @@
    checked for 'port_state'. the actions and events may or may not change
    'port_state' by calling toState(), but once they are done we loop around
    again and perform the actions required for the new 'port_state'. */
-void 
+void
 protocol(RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	DBG("event POWERUP\n");
@@ -105,75 +107,83 @@
 
 
 /* perform actions required when leaving 'port_state' and entering 'state' */
-void 
+void
 toState(UInteger8 state, RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	ptpClock->message_activity = TRUE;
-	
+
 	/* leaving state tasks */
 	switch (ptpClock->portState)
 	{
 	case PTP_MASTER:
-		timerStop(SYNC_INTERVAL_TIMER, ptpClock->itimer);  
+		timerStop(SYNC_INTERVAL_TIMER, ptpClock->itimer);
 		timerStop(ANNOUNCE_INTERVAL_TIMER, ptpClock->itimer);
-		timerStop(PDELAYREQ_INTERVAL_TIMER, ptpClock->itimer); 
+		timerStop(PDELAYREQ_INTERVAL_TIMER, ptpClock->itimer);
 		break;
-		
+
 	case PTP_SLAVE:
 		timerStop(ANNOUNCE_RECEIPT_TIMER, ptpClock->itimer);
-		
+
 		if (ptpClock->delayMechanism == E2E)
 			timerStop(DELAYREQ_INTERVAL_TIMER, ptpClock->itimer);
 		else if (ptpClock->delayMechanism == P2P)
 			timerStop(PDELAYREQ_INTERVAL_TIMER, ptpClock->itimer);
-		
-		initClock(rtOpts, ptpClock); 
+
+    /* bug 25796 - Don't reset the servo when entering or leaving the slave state.
+     * Instead we assume let the servo continue to work. If the time on a the next
+     * master is significantly different, this will cause a servo reset and a time
+     * correction. Otherwise we will converge as normal.
+     * initClock(rtOpts, ptpClock);
+     */
 		break;
-		
+
 	case PTP_PASSIVE:
 		timerStop(PDELAYREQ_INTERVAL_TIMER, ptpClock->itimer);
 		timerStop(ANNOUNCE_RECEIPT_TIMER, ptpClock->itimer);
 		break;
-		
+
 	case PTP_LISTENING:
 		timerStop(ANNOUNCE_RECEIPT_TIMER, ptpClock->itimer);
 		break;
-		
+
 	default:
 		break;
 	}
-	
+
 	/* entering state tasks */
 
 	/*
 	 * No need of PRE_MASTER state because of only ordinary clock
 	 * implementation.
 	 */
-	
+
 	switch (state)
 	{
 	case PTP_INITIALIZING:
 		DBG("state PTP_INITIALIZING\n");
+		INFO("state -> initialising\n");
 		ptpClock->portState = PTP_INITIALIZING;
 		break;
-		
+
 	case PTP_FAULTY:
 		DBG("state PTP_FAULTY\n");
+		INFO("state -> faulty\n");
 		ptpClock->portState = PTP_FAULTY;
 		break;
-		
+
 	case PTP_DISABLED:
 		DBG("state PTP_DISABLED\n");
+		INFO("state -> disabled\n");
 		ptpClock->portState = PTP_DISABLED;
 		break;
-		
+
 	case PTP_LISTENING:
 		/* in Listening mode, make sure we don't send anything. Instead we just expect/wait for announces (started below) */
 		timerStop(SYNC_INTERVAL_TIMER,      ptpClock->itimer);
 		timerStop(ANNOUNCE_INTERVAL_TIMER,  ptpClock->itimer);
 		timerStop(PDELAYREQ_INTERVAL_TIMER, ptpClock->itimer);
 		timerStop(DELAYREQ_INTERVAL_TIMER,  ptpClock->itimer);
-		
+
 		/*
 		 *  Count how many _unique_ timeouts happen to us.
 		 *  If we were already in Listen mode, then do not count this as a seperate reset, but stil do a new IGMP refresh
@@ -183,51 +193,52 @@
 		}
 
 		/* Revert to the original DelayReq interval, and ignore the one for the last master */
-		ptpClock->logMinDelayReqInterval = rtOpts->initial_delayreq;
+		ptpClock->minDelayReqInterval = rtOpts->initial_delayreq;
+		ptpClock->logMinDelayReqInterval = log2IntegerSaturateAtZero(rtOpts->initial_delayreq);
 
 		/* force a IGMP refresh per reset */
 		if (rtOpts->do_IGMP_refresh) {
 			netRefreshIGMP(&ptpClock->netPath, rtOpts, ptpClock);
 		}
-		
+
 
 		DBG("state PTP_LISTENING\n");
-		INFO("  now in state PTP_LISTENING\n");
-		timerStart(ANNOUNCE_RECEIPT_TIMER, 
+		INFO("state -> listening\n");
+		timerStart(ANNOUNCE_RECEIPT_TIMER,
 			   (ptpClock->announceReceiptTimeout) * 
-			   (pow(2,ptpClock->logAnnounceInterval)), 
+			   rtOpts->announceInterval,
 			   ptpClock->itimer);
 		ptpClock->portState = PTP_LISTENING;
 		break;
 
 	case PTP_MASTER:
 		DBG("state PTP_MASTER\n");
-		INFO("  now in state PTP_MASTER\n");
-		
+		INFO("state -> master\n");
+
 		timerStart(SYNC_INTERVAL_TIMER, 
-			   pow(2,ptpClock->logSyncInterval), ptpClock->itimer);
-		DBG("SYNC INTERVAL TIMER : %f \n",
-		    pow(2,ptpClock->logSyncInterval));
+				rtOpts->syncInterval, ptpClock->itimer);
+		DBG("SYNC INTERVAL TIMER : %Lf \n",
+				rtOpts->syncInterval);
 		timerStart(ANNOUNCE_INTERVAL_TIMER, 
-			   pow(2,ptpClock->logAnnounceInterval), 
-			   ptpClock->itimer);
-		timerStart(PDELAYREQ_INTERVAL_TIMER, 
-			   pow(2,ptpClock->logMinPdelayReqInterval), 
+				rtOpts->announceInterval, 
+				ptpClock->itimer);
+		timerStart(PDELAYREQ_INTERVAL_TIMER,
+			   pow(2,ptpClock->logMinPdelayReqInterval),
 			   ptpClock->itimer);
 		ptpClock->portState = PTP_MASTER;
 		break;
 
 	case PTP_PASSIVE:
 		DBG("state PTP_PASSIVE\n");
-		INFO("  now in state PTP_PASSIVE\n");
+		INFO("state -> passive\n");
 
-		
-		timerStart(PDELAYREQ_INTERVAL_TIMER, 
-			   pow(2,ptpClock->logMinPdelayReqInterval), 
+
+		timerStart(PDELAYREQ_INTERVAL_TIMER,
+			   pow(2,ptpClock->logMinPdelayReqInterval),
 			   ptpClock->itimer);
-		timerStart(ANNOUNCE_RECEIPT_TIMER, 
+		timerStart(ANNOUNCE_RECEIPT_TIMER,
 			   (ptpClock->announceReceiptTimeout) * 
-			   (pow(2,ptpClock->logAnnounceInterval)), 
+			   rtOpts->announceInterval,
 			   ptpClock->itimer);
 		ptpClock->portState = PTP_PASSIVE;
 		p1(ptpClock, rtOpts);
@@ -235,15 +246,21 @@
 
 	case PTP_UNCALIBRATED:
 		DBG("state PTP_UNCALIBRATED\n");
+		INFO("state -> uncalibrated\n");
 		ptpClock->portState = PTP_UNCALIBRATED;
 		break;
 
 	case PTP_SLAVE:
 		DBG("state PTP_SLAVE\n");
-		INFO("  now in state PTP_SLAVE\n");
-		
-		initClock(rtOpts, ptpClock);
-		
+		INFO("state -> slave\n");
+
+		/* bug 25796 - Don't reset the servo when entering or leaving the slave state.
+		 * Instead we assume let the servo continue to work. If the time on a the next
+		 * master is significantly different, this will cause a servo reset and a time
+		 * correction. Otherwise we will converge as normal.
+		 * initClock(rtOpts, ptpClock);
+		 */
+
 		ptpClock->waitingForFollow = FALSE;
 		ptpClock->waitingForDelayResp = FALSE;
 
@@ -252,16 +269,16 @@
 		clearTime(&ptpClock->pdelay_req_receive_time);
 		clearTime(&ptpClock->pdelay_resp_send_time);
 		clearTime(&ptpClock->pdelay_resp_receive_time);
-		
+
 		timerStart(OPERATOR_MESSAGES_TIMER,
 			   OPERATOR_MESSAGES_INTERVAL,
 			   ptpClock->itimer);
 		
 		timerStart(ANNOUNCE_RECEIPT_TIMER,
 			   (ptpClock->announceReceiptTimeout) * 
-			   (pow(2,ptpClock->logAnnounceInterval)), 
+			   rtOpts->announceInterval,
 			   ptpClock->itimer);
-		
+
 		/*
 		 * Previously, this state transition would start the delayreq timer immediately.
 		 * However, if this was faster than the first received sync, then the servo would drop the delayResp
@@ -271,6 +288,24 @@
 		ptpClock->waiting_for_first_delayresp = TRUE;
 
 		ptpClock->portState = PTP_SLAVE;
+
+#if !defined(__APPLE__)
+
+		/* 
+		 * leap second pending in kernel but no leap second 
+		 * info from GM - withdraw kernel leap second
+		 * if the flags have disappeared but we're past 
+		 * leap second event, do nothing - kernel flags 
+		 * will be unset in handleAnnounce()
+		 */
+		if((!ptpClock->leap59 && !ptpClock->leap61) &&
+		    !ptpClock->leapSecondInProgress &&
+		   (checkTimexFlags(STA_INS) || checkTimexFlags(STA_DEL))) {
+			WARNING("=== Leap second pending in kernel but not on "
+				"GM: aborting kernel leap second\n");
+			unsetTimexFlags(STA_INS | STA_DEL, TRUE);
+		}
+#endif /* apple */
 		break;
 
 	default:
@@ -283,11 +318,12 @@
 }
 
 
-Boolean 
+Boolean
 doInit(RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
+	NOTIFY("ptpd version: %s\n", PTP_VERSION_STRING);
 	DBG("manufacturerIdentity: %s\n", MANUFACTURER_ID);
-	
+
 	/* initialize networking */
 	netShutdown(&ptpClock->netPath);
 	if (!netInit(&ptpClock->netPath, rtOpts, ptpClock)) {
@@ -295,27 +331,36 @@
 		toState(PTP_FAULTY, rtOpts, ptpClock);
 		return FALSE;
 	}
-	
+
+	/* initialize other stuff, including HW if needed */
+	shutdownTime(ptpClock);
+	if(!initTime(rtOpts, ptpClock))
+	{
+	    ERROR("failed to initialize timing\n");
+	    toState(PTP_FAULTY, rtOpts, ptpClock);
+	    return FALSE;
+	}
+
 	/* initialize other stuff */
 	initData(rtOpts, ptpClock);
 	initTimer();
 	initClock(rtOpts, ptpClock);
 	m1(rtOpts, ptpClock );
-	msgPackHeader(ptpClock->msgObuf, ptpClock);
-	
+	msgPackHeader(ptpClock->msgObuf, ptpClock, SYNC);
+
 	toState(PTP_LISTENING, rtOpts, ptpClock);
-	
+
 	return TRUE;
 }
 
 /* handle actions and events for 'port_state' */
-void 
+void
 doState(RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	UInteger8 state;
-	
+
 	ptpClock->message_activity = FALSE;
-	
+
 	/* Process record_update (BMC algorithm) before everything else */
 	switch (ptpClock->portState)
 	{
@@ -335,11 +380,11 @@
 				toState(state, rtOpts, ptpClock);
 		}
 		break;
-		
+
 	default:
 		break;
 	}
-	
+
 	
 	switch (ptpClock->portState)
 	{
@@ -348,14 +393,26 @@
 		DBG("event FAULT_CLEARED\n");
 		toState(PTP_INITIALIZING, rtOpts, ptpClock);
 		return;
-		
+
 	case PTP_LISTENING:
 	case PTP_UNCALIBRATED:
 	case PTP_SLAVE:
 	// passive mode behaves like the SLAVE state, in order to wait for the announce timeout of the current active master
 	case PTP_PASSIVE:
+
+		/* If we are in time both mode sync the system and local NIC. This process will continue
+                 * even if we lose contact with the master. Note that we only do this if ptpd was
+		 * started in a master mode or the primary servo has updated the clock at least once.
+		 * bug 26688 This avoids the scenario during slave start up where we start syncing the
+		 * system time to the NIC time before the NIC is synced to the master.
+		 */
+		if ((rtOpts->time_mode == TIME_BOTH) &&
+		    ((rtOpts->master_slave_mode != PTP_MODE_SLAVE) || ptpClock->clock_first_updated)) {
+			syncSystemWithNIC(rtOpts, ptpClock);
+		}
+		
 		handle(rtOpts, ptpClock);
-		
+
 		/*
 		 * handle SLAVE timers:
 		 *   - No Announce message was received
@@ -367,7 +424,7 @@
 			ptpClock->number_foreign_records = 0;
 			ptpClock->foreign_record_i = 0;
 
-			if(!ptpClock->slaveOnly && 
+			if(rtOpts->master_slave_mode != PTP_MODE_SLAVE &&
 			   ptpClock->clockQuality.clockClass != 255) {
 				m1(rtOpts,ptpClock);
 				toState(PTP_MASTER, rtOpts, ptpClock);
@@ -380,7 +437,7 @@
 				toState(PTP_LISTENING, rtOpts, ptpClock);
 			}
 		}
-		
+
 		if (timerExpired(OPERATOR_MESSAGES_TIMER, ptpClock->itimer)) {
 			reset_operator_messages(rtOpts, ptpClock);
 		}
@@ -396,32 +453,113 @@
 			if (timerExpired(PDELAYREQ_INTERVAL_TIMER,
 					ptpClock->itimer)) {
 				DBGV("event PDELAYREQ_INTERVAL_TIMEOUT_EXPIRES\n");
-				issuePDelayReq(rtOpts,ptpClock);
+ 				issuePDelayReq(rtOpts,ptpClock);
 			}
 
 			/* FIXME: Path delay should also rearm its timer with the value received from the Master */
 		}
+
+		/* XXX wowczarek: handle leap second timers */
+		if (ptpClock->leap59 || ptpClock->leap61) 
+			DBGV("seconds to midnight: %f\n", secondsToMidnight());
+
+		if(timerExpired(LEAP_SECOND_PENDING_TIMER,ptpClock->itimer)) {
+			/* leap second period is over */
+			if(ptpClock->leapSecondInProgress) {
+				/* 
+				 * do not unpause offset calculation just
+				 * yet, just indicate and it will be
+				 * unpaused in handleAnnounce
+				 */
+				ptpClock->leapSecondPending = FALSE;
+				timerStop(LEAP_SECOND_PENDING_TIMER,ptpClock->itimer);
+			/* leap second period has just started */
+			} else if(ptpClock->leapSecondPending) {
+				WARNING("=== Leap second event imminent - pausing "
+					"offset updates\n");
+				ptpClock->leapSecondInProgress = TRUE;
+#if !defined(__APPLE__)
+				if (!rtOpts->noResetClock && !rtOpts->resetClockStartupOnly &&
+				    !checkTimexFlags(ptpClock->leap61 ? STA_INS : STA_DEL)) {
+					WARNING("=== Kernel leap second flags have "
+						"been unset - attempting to set "
+						"again");
+					setTimexFlags(ptpClock->leap61 ? 
+						      STA_INS : STA_DEL, FALSE);
+				}
+#endif /* apple */
+				timerStart(LEAP_SECOND_PENDING_TIMER,
+					getPauseBeforeMidnight(ptpClock->logAnnounceInterval) + 
+					getPauseAfterMidnight(ptpClock->logAnnounceInterval),
+					ptpClock->itimer);
+
+				if (ptpClock->leap61) {
+					timerStart(LEAP_SECOND_NOW_TIMER,
+						secondsToMidnight(),
+						ptpClock->itimer);
+				} else {
+					timerStart(LEAP_SECOND_NOW_TIMER,
+						secondsToMidnight() - 1.0,
+						ptpClock->itimer);
+				}
+			}
+		}
+
+		if(timerExpired(LEAP_SECOND_NOW_TIMER,ptpClock->itimer)) {
+			if (ptpClock->leap61) {
+				WARNING("=== Leap second added!\n");
+				adjTimeInsertLeapSecond(rtOpts->time_mode, rtOpts, ptpClock);
+			} else {
+				WARNING("=== Leap second deleted!\n");
+				adjTimeDeleteLeapSecond(rtOpts->time_mode, rtOpts, ptpClock);
+			}
+			timerStop(LEAP_SECOND_NOW_TIMER,ptpClock->itimer);
+		}
 		break;
 
 	case PTP_MASTER:
+
+		/* If we are in time both mode, sync the system and local NIC. This process will continue
+		 * irrespective of whether theere is communication with one or more slave nodes.
+		 */
+		if (rtOpts->time_mode == TIME_BOTH) {
+			syncSystemWithNIC(rtOpts, ptpClock);
+		}
+
 		/*
-		 * handle SLAVE timers:
+		 * handle MASTER timers:
 		 *   - Time to send new Sync
 		 *   - Time to send new Announce
 		 *   - Time to send new PathDelay
 		 *      (DelayResp has no timer - as these are sent and retransmitted by the slaves)
 		 */
-	
+
+#ifdef DBG_SIGRTMIN_LEAP_SECOND
+                if(timerExpired(LEAP_SECOND_NOW_TIMER, ptpClock->itimer)) {
+			/* If we are signalling a leap second, apply the adjustment
+			 * and cancel the signalling.
+			 */
+			if (ptpClock->leap61)
+				ptpClock->currentUtcOffset++;
+			if (ptpClock->leap59)
+				ptpClock->currentUtcOffset--;
+			INFO("Setting UTC offset to %d\n", ptpClock->currentUtcOffset);
+			ptpClock->leap61 = FALSE;
+			ptpClock->leap59 = FALSE;
+			timerStop(LEAP_SECOND_NOW_TIMER, ptpClock->itimer);
+		}
+#endif
+
 		if (timerExpired(SYNC_INTERVAL_TIMER, ptpClock->itimer)) {
 			DBGV("event SYNC_INTERVAL_TIMEOUT_EXPIRES\n");
 			issueSync(rtOpts, ptpClock);
 		}
-		
+
 		if (timerExpired(ANNOUNCE_INTERVAL_TIMER, ptpClock->itimer)) {
 			DBGV("event ANNOUNCE_INTERVAL_TIMEOUT_EXPIRES\n");
 			issueAnnounce(rtOpts, ptpClock);
 		}
-		
+
 		if (ptpClock->delayMechanism == P2P) {
 			if (timerExpired(PDELAYREQ_INTERVAL_TIMER,
 					ptpClock->itimer)) {
@@ -429,19 +567,20 @@
 				issuePDelayReq(rtOpts,ptpClock);
 			}
 		}
-		
+
 		// TODO: why is handle() below expiretimer, while in slave is the opposite
 		handle(rtOpts, ptpClock);
-		
-		if (ptpClock->slaveOnly || ptpClock->clockQuality.clockClass == 255)
+
+		if (rtOpts->master_slave_mode == PTP_MODE_SLAVE ||
+		   ptpClock->clockQuality.clockClass == 255)
 			toState(PTP_LISTENING, rtOpts, ptpClock);
-		
+
 		break;
 
 	case PTP_DISABLED:
 		handle(rtOpts, ptpClock);
 		break;
-		
+
 	default:
 		DBG("(doState) do unrecognized state\n");
 		break;
@@ -456,57 +595,54 @@
 	int ret;
 	ssize_t length;
 	Boolean isFromSelf;
+	Boolean isEvent;
+	Boolean isLoopedBackTx = FALSE;
 	TimeInternal time = { 0, 0 };
 
 	if (!ptpClock->message_activity) {
-		ret = netSelect(0, &ptpClock->netPath);
-		if (ret < 0) {
-			PERROR("failed to poll sockets");
+		/* To support time both mode, we time-out after a  second to allow the
+		 * the system clock to be synced to the NIC clock. For other modes, this
+		 * should have no effect on the behaviour. */
+		TimeInternal timeout;
+		double integerPart, fractionalPart;
+		fractionalPart = modf(rtOpts->system_time_update_interval, &integerPart);
+		timeout.seconds = (Integer32)integerPart;
+		timeout.nanoseconds = (Integer32)(fractionalPart * 1000000000.0);
+
+		ret = netSelect(&timeout, &ptpClock->netPath);
+		if(ret < 0) {
+			PERROR("failed to poll sockets\n");
 			toState(PTP_FAULTY, rtOpts, ptpClock);
 			return;
 		} else if (!ret) {
-			/* DBGV("handle: nothing\n"); */
+			/* We timed out, return immediately. */
 			return;
 		}
 		/* else length > 0 */
 	}
 
-	DBGV("handle: something\n");
+	/*DBGV("handle: something\n");*/
 
-	/* TODO: this should be based on the select actual FDs (if(FD_ISSET(...)) */
-	length = netRecvEvent(ptpClock->msgIbuf, &time, &ptpClock->netPath);
-
-
+	isEvent = TRUE;
+	length = netRecvEvent(ptpClock->msgIbuf, &time, ptpClock,
+                          rtOpts,
+                          &isLoopedBackTx);
 	if (length < 0) {
-		PERROR("failed to receive on the event socket");
+		PERROR("failed to receive on the event socket\n");
 		toState(PTP_FAULTY, rtOpts, ptpClock);
 		return;
 	} else if (!length) {
+		isEvent = FALSE;
 		length = netRecvGeneral(ptpClock->msgIbuf, &time,
-					&ptpClock->netPath);
+					ptpClock, rtOpts);
 		if (length < 0) {
-			PERROR("failed to receive on the general socket");
+			PERROR("failed to receive on the general socket\n");
 			toState(PTP_FAULTY, rtOpts, ptpClock);
 			return;
 		} else if (!length)
 			return;
 	}
 
-	/*
-	 * make sure we use the TAI to UTC offset specified, if the master is sending the UTC_VALID bit
-	 *
-	 *
-	 * On the slave, all timestamps that we handle here have been collected by our local clock (loopback+kernel-level timestamp)
-	 * This includes delayReq just send, and delayResp, when it arrives.
-	 *
-	 * these are then adjusted to the same timebase of the Master (+34 leap seconds, as of 2011)
-	 *
-	 */
-	DBGV("__UTC_offset: %d %d \n", ptpClock->currentUtcOffsetValid, ptpClock->currentUtcOffset);
-	if (ptpClock->currentUtcOffsetValid) {
-		time.seconds += ptpClock->currentUtcOffset;
-	}
-
 	ptpClock->message_activity = TRUE;
 
 	if (length < HEADER_LENGTH) {
@@ -517,6 +653,30 @@
 
 	msgUnpackHeader(ptpClock->msgIbuf, &ptpClock->msgTmpHeader);
 
+	if(isEvent && !isLoopedBackTx && (ptpClock->tsMethod == TS_METHOD_DRIVER_IOCTL)) {
+		/* query hardware for matching receive time stamp */
+		if(!getReceiveTime(&time,
+                       ptpClock->msgTmpHeader.sourcePortIdentity.clockIdentity,
+                       ptpClock->msgTmpHeader.sequenceId, rtOpts->time_mode, &ptpClock->netPath)) {
+				/*
+				 * This doesn't apply to us as we can timestamp sync and delay requests:
+				 * "Incoming packets without hardware time stamp cannot be ignored outright because
+				 * a master might only be able to time stamp DelayReq packets; ignoring the Sync
+				 * packets from another, better clock would break the clock selection protocol.
+				 * Therefore set system time as fallback and decide below what to do."
+				 * Instead, ignore the packet outright!
+				 */
+				DBGV("*** message with no time stamp ***\n");
+				return;
+		}
+	}
+
+	/* make sure we use the TAI to UTC offset specified, if the master is sending the UTC_VALID bit */
+	DBG2("__UTC_offset: %d %d \n", ptpClock->currentUtcOffsetValid, ptpClock->currentUtcOffset);
+	if((rtOpts->master_slave_mode == PTP_MODE_SLAVE) && ptpClock->currentUtcOffsetValid){
+		time.seconds += ptpClock->currentUtcOffset;
+	}	
+
 	if (ptpClock->msgTmpHeader.versionPTP != ptpClock->versionNumber) {
 		DBG2("ignore version %d message\n", ptpClock->msgTmpHeader.versionPTP);
 		return;
@@ -527,13 +687,13 @@
 		return;
 	}
 
-	/*Spec 9.5.2.2*/	
+	/*Spec 9.5.2.2*/
 	isFromSelf = (ptpClock->portIdentity.portNumber == ptpClock->msgTmpHeader.sourcePortIdentity.portNumber
 		      && !memcmp(ptpClock->msgTmpHeader.sourcePortIdentity.clockIdentity, ptpClock->portIdentity.clockIdentity, CLOCK_IDENTITY_LENGTH));
 
 	/*
 	 * subtract the inbound latency adjustment if it is not a loop
-	 *  back and the time stamp seems reasonable 
+	 *  back and the time stamp seems reasonable
 	 */
 	if (!isFromSelf && time.seconds > 0)
 		subTime(&time, &time, &rtOpts->inboundLatency);
@@ -576,27 +736,27 @@
 	switch (ptpClock->msgTmpHeader.messageType)
 	{
 	case ANNOUNCE:
-		handleAnnounce(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleAnnounce(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 			       length, isFromSelf, rtOpts, ptpClock);
 		break;
 	case SYNC:
-		handleSync(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleSync(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 			   length, &time, isFromSelf, rtOpts, ptpClock);
 		break;
 	case FOLLOW_UP:
-		handleFollowUp(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleFollowUp(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 			       length, isFromSelf, rtOpts, ptpClock);
 		break;
 	case DELAY_REQ:
-		handleDelayReq(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleDelayReq(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 			       length, &time, isFromSelf, rtOpts, ptpClock);
 		break;
 	case PDELAY_REQ:
-		handlePDelayReq(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handlePDelayReq(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 				length, &time, isFromSelf, rtOpts, ptpClock);
-		break;  
+		break;
 	case DELAY_RESP:
-		handleDelayResp(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleDelayResp(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 				length, isFromSelf, rtOpts, ptpClock);
 		break;
 	case PDELAY_RESP:
@@ -604,16 +764,16 @@
 				 &time, length, isFromSelf, rtOpts, ptpClock);
 		break;
 	case PDELAY_RESP_FOLLOW_UP:
-		handlePDelayRespFollowUp(&ptpClock->msgTmpHeader, 
-					 ptpClock->msgIbuf, length, 
+		handlePDelayRespFollowUp(&ptpClock->msgTmpHeader,
+					 ptpClock->msgIbuf, length,
 					 isFromSelf, rtOpts, ptpClock);
 		break;
 	case MANAGEMENT:
-		handleManagement(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleManagement(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 				 length, isFromSelf, rtOpts, ptpClock);
 		break;
 	case SIGNALING:
-		handleSignaling(&ptpClock->msgTmpHeader, ptpClock->msgIbuf, 
+		handleSignaling(&ptpClock->msgTmpHeader, ptpClock->msgIbuf,
 				length, isFromSelf, rtOpts, ptpClock);
 		break;
 	default:
@@ -627,11 +787,11 @@
 }
 
 /*spec 9.5.3*/
-void 
-handleAnnounce(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
+void
+handleAnnounce(MsgHeader *header, Octet *msgIbuf, ssize_t length,
 	       Boolean isFromSelf, RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
-	Boolean isFromCurrentParent = FALSE; 
+	Boolean isFromCurrentParent = FALSE;
 
 	DBGV("HandleAnnounce : Announce message received : \n");
 
@@ -650,40 +810,63 @@
 	case PTP_DISABLED:
 		DBG("Handleannounce : disregard\n");
 		return;
-		
-	case PTP_UNCALIBRATED:	
+
+	case PTP_UNCALIBRATED:
 	case PTP_SLAVE:
 		if (isFromSelf) {
 			DBGV("HandleAnnounce : Ignore message from self \n");
 			return;
 		}
-		
+
 		/*
 		 * Valid announce message is received : BMC algorithm
-		 * will be executed 
+		 * will be executed
 		 */
 		ptpClock->record_update = TRUE;
 
 		isFromCurrentParent = !memcmp(
 			ptpClock->parentPortIdentity.clockIdentity,
 			header->sourcePortIdentity.clockIdentity,
-			CLOCK_IDENTITY_LENGTH)	&& 
-			(ptpClock->parentPortIdentity.portNumber == 
+			CLOCK_IDENTITY_LENGTH)	&&
+			(ptpClock->parentPortIdentity.portNumber ==
 			 header->sourcePortIdentity.portNumber);
-	
+
 		switch (isFromCurrentParent) {
 		case TRUE:
 	   		msgUnpackAnnounce(ptpClock->msgIbuf,
 					  &ptpClock->msgTmp.announce);
 
-			/* update datasets (file bmc.c) */
+			/* If the leap second period is over (pending == FALSE,
+			 * inProgress == TRUE), unpause offset calculation
+			 * (received first announce after leap second)
+			 * Note that we must be this before running the BMC
+			 * algorithm as this can set leapSecondPending again.
+			 */
+			if(ptpClock->leapSecondInProgress &&
+			   !ptpClock->leapSecondPending) {
+				WARNING("=== Leap second event over - "
+					"resuming offset updates\n");
+				ptpClock->leapSecondInProgress = FALSE;
+				ptpClock->leap59 = FALSE;
+				ptpClock->leap61 = FALSE;
+				unsetTimexFlags(STA_INS | STA_DEL, TRUE);
+			}
+			
+			/* call the BMC algorithm (file bmc.c) */
 	   		s1(header,&ptpClock->msgTmp.announce,ptpClock, rtOpts);
 
+
+			/* update current master in the fmr as well */
+			memcpy(&ptpClock->foreign[ptpClock->foreign_record_best].header,
+			       header,sizeof(MsgHeader));
+			memcpy(&ptpClock->foreign[ptpClock->foreign_record_best].announce,
+			       &ptpClock->msgTmp.announce,sizeof(MsgAnnounce));
+
 			DBG2("___ Announce: received Announce from current Master, so reset the Announce timer\n");
 	   		/*Reset Timer handling Announce receipt timeout*/
 	   		timerStart(ANNOUNCE_RECEIPT_TIMER,
 				   (ptpClock->announceReceiptTimeout) * 
-				   (pow(2,ptpClock->logAnnounceInterval)), 
+				   rtOpts->announceInterval,
 				   ptpClock->itimer);
 
 #ifdef PTP_EXPERIMENTAL
@@ -691,20 +874,20 @@
 			// todo: add this to bmc(), to cover the very first packet
 			ptpClock->MasterAddr = ptpClock->netPath.lastRecvAddr;
 #endif
-			break;
+	   		break;
 
 		case FALSE:
-			/*addForeign takes care of AnnounceUnpacking*/
+	   		/*addForeign takes care of AnnounceUnpacking*/
 			/* the actual decision to change masters is only done in  doState() / record_update == TRUE / bmc() */
-			
+
 			/* the original code always called: addforeign(new master) + timerstart(announce) */
 
 			addForeign(ptpClock->msgIbuf,header,ptpClock);
-			timerStart(ANNOUNCE_RECEIPT_TIMER,
+	   		timerStart(ANNOUNCE_RECEIPT_TIMER,
 				   (ptpClock->announceReceiptTimeout) * 
-				   (pow(2,ptpClock->logAnnounceInterval)), 
+				   rtOpts->announceInterval,
 				   ptpClock->itimer);
-			break;
+	   		break;
 
 		default:
 			DBG("HandleAnnounce : (isFromCurrentParent)"
@@ -718,7 +901,7 @@
 	 * Passive case: previously, this was handled in the default, just like the master case.
 	 * This the announce would call addForeign(), but NOT reset the timer, so after 12s it would expire and we would come alive periodically 
 	 *
-	 * This code is now merged with the slave case to reset the timer, and call addForeign() if it's a third master
+	 * This code is now merged with the slave case to reset the timer, and  call addForeign() if it's a third master
 	 *
 	 */
 	case PTP_PASSIVE:
@@ -756,7 +939,7 @@
 			/*Reset Timer handling Announce receipt timeout*/
 			timerStart(ANNOUNCE_RECEIPT_TIMER,
 				   (ptpClock->announceReceiptTimeout) *
-				   (pow(2,ptpClock->logAnnounceInterval)),
+				   rtOpts->announceInterval,
 				   ptpClock->itimer);
 		} else {
 			/*addForeign takes care of AnnounceUnpacking*/
@@ -769,27 +952,27 @@
 		}
 		break;
 
-		
+
 	case PTP_MASTER:
-	case PTP_LISTENING:           /* listening mode still causes timeouts in order to send IGMP refreshes */
+	case PTP_LISTENING:			/* listening mode still causes timeouts in order to send IGMP refreshes */
 	default :
-		if (isFromSelf) {
+		if (isFromSelf)	{
 			DBGV("HandleAnnounce : Ignore message from self \n");
 			return;
 		}
 
 		DBGV("Announce message from another foreign master\n");
 		addForeign(ptpClock->msgIbuf,header,ptpClock);
-		ptpClock->record_update = TRUE;    /* run BMC() as soon as possible */
+		ptpClock->record_update = TRUE;		/* run BMC() as soon as possible */
 		break;
 
 	} /* switch on (port_state) */
 }
 
 
-void 
-handleSync(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
-	   TimeInternal *time, Boolean isFromSelf, 
+void
+handleSync(MsgHeader *header, Octet *msgIbuf, ssize_t length,
+	   TimeInternal *time, Boolean isFromSelf,
 	   RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	TimeInternal OriginTimestamp;
@@ -797,12 +980,12 @@
 
 	Boolean isFromCurrentParent = FALSE;
 	DBGV("Sync message received : \n");
-	
+
 	if (length < SYNC_LENGTH) {
 		ERROR("short Sync message\n");
 		toState(PTP_FAULTY, rtOpts, ptpClock);
 		return;
-	}	
+	}
 
 	switch (ptpClock->portState) {
 	case PTP_INITIALIZING:
@@ -810,8 +993,8 @@
 	case PTP_DISABLED:
 		DBGV("HandleSync : disregard\n");
 		return;
-		
-	case PTP_UNCALIBRATED:	
+
+	case PTP_UNCALIBRATED:
 	case PTP_SLAVE:
 		if (isFromSelf) {
 			DBGV("HandleSync: Ignore message from self \n");
@@ -820,27 +1003,27 @@
 		isFromCurrentParent =
 			!memcmp(ptpClock->parentPortIdentity.clockIdentity,
 				header->sourcePortIdentity.clockIdentity,
-				CLOCK_IDENTITY_LENGTH) && 
-			(ptpClock->parentPortIdentity.portNumber == 
+				CLOCK_IDENTITY_LENGTH) &&
+			(ptpClock->parentPortIdentity.portNumber ==
 			 header->sourcePortIdentity.portNumber);
-		
+
 		if (isFromCurrentParent) {
 			/* We only start our own delayReq timer after receiving the first sync */
 			if (ptpClock->waiting_for_first_sync) {
 				ptpClock->waiting_for_first_sync = FALSE;
 				NOTICE("Received first Sync from Master\n");
-				NOTICE("   going to arm DelayReq timer for the first time, with initial rate: %d\n",
-					ptpClock->logMinDelayReqInterval
+				NOTICE("   going to arm DelayReq timer for the first time, with initial rate: %Lf\n",
+					ptpClock->minDelayReqInterval
 				);
 
 				if (ptpClock->delayMechanism == E2E)
 					timerStart(DELAYREQ_INTERVAL_TIMER,
-						   pow(2,ptpClock->logMinDelayReqInterval),
-						   ptpClock->itimer);
+							ptpClock->minDelayReqInterval,
+							ptpClock->itimer);
 				else if (ptpClock->delayMechanism == P2P)
 					timerStart(PDELAYREQ_INTERVAL_TIMER,
-						   pow(2,ptpClock->logMinPdelayReqInterval),
-						   ptpClock->itimer);
+                               pow(2,ptpClock->logMinPdelayReqInterval),
+                               ptpClock->itimer);
 			}
 
 			ptpClock->sync_receive_time.seconds = time->seconds;
@@ -852,13 +1035,13 @@
 				DBG2("HandleSync: waiting for follow-up \n");
 
 				ptpClock->waitingForFollow = TRUE;
-				ptpClock->recvSyncSequenceId = 
+				ptpClock->recvSyncSequenceId =
 					header->sequenceId;
 				/*Save correctionField of Sync message*/
 				integer64_to_internalTime(
 					header->correctionfield,
 					&correctionField);
-				ptpClock->lastSyncCorrectionField.seconds = 
+				ptpClock->lastSyncCorrectionField.seconds =
 					correctionField.seconds;
 				ptpClock->lastSyncCorrectionField.nanoseconds =
 					correctionField.nanoseconds;
@@ -895,9 +1078,9 @@
 		} if (ptpClock->twoStepFlag) {
 			DBGV("HandleSync: going to send followup message\n ");
 
-			/*Add latency*/
-			addTime(time,time,&rtOpts->outboundLatency);
-			issueFollowup(time,rtOpts,ptpClock);
+      /*Add latency*/
+      addTime(time,time,&rtOpts->outboundLatency);
+      issueFollowup(time,rtOpts,ptpClock);
 			break;
 		} else {
 			DBGV("HandleSync: Sync message received from self\n ");
@@ -906,17 +1089,17 @@
 }
 
 
-void 
-handleFollowUp(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
+void
+handleFollowUp(MsgHeader *header, Octet *msgIbuf, ssize_t length,
 	       Boolean isFromSelf, RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	DBGV("Handlefollowup : Follow up message received \n");
-	
+
 	TimeInternal preciseOriginTimestamp;
 	TimeInternal correctionField;
 	Boolean isFromCurrentParent = FALSE;
-	
-	if (length < FOLLOW_UP_LENGTH)
+
+	if(length < FOLLOW_UP_LENGTH)
 	{
 		ERROR("short Follow up message\n");
 		toState(PTP_FAULTY, rtOpts, ptpClock);
